#!/usr/bin/perl -w
##################################################
# mschilli@perlmeister.com, 1999
# One-Pixel Image Cookie-Tracker
##################################################
use CGI qw(:standard);

$VERSION     = "100";
$COOKIE_NAME = "id";
$LOG_FILE    = "/DATA/track.dat";

if(defined ($v=cookie(-name => $COOKIE_NAME))) {

    print header('-type'    => "image/gif", 
                 '-expires' => '-1y');

    my ($ve, $ip, $ct, $id) = 
        ($v =~ /VE(\S+) IP(\S+) CT(\S+) ID(\S+)/);

    if(defined $id) {
        logmsg("R $ip $id $ct $ve",
        $ENV{HTTP_REFERER} || '-', 
        $ENV{HTTP_USER_AGENT} || '-');
    }

} else {

    my $ve  = $VERSION;
    my $ip  = $ENV{'REMOTE_ADDR'};
    my $ct  = time();
    my $id  = time() . $$;
    my $cookie = "VE$ve IP$ip CT$ct ID$id";

    logmsg("F $ip $id $ct $ve",
        $ENV{HTTP_REFERER} || '-', 
        $ENV{HTTP_USER_AGENT} || '-');

    $cookie = cookie(
      '-name'    => $COOKIE_NAME,
      '-value'   => $cookie,
      '-expires' => '+1y', -path => '/'
    );

    print header('-type'    => 'image/gif',
                 '-cookie'  => $cookie,
                 '-expires' => '-1y');
}

print unpack('u', 'C1TE&.#=A`0`!`(```/_<N@```"P`'.
             '`````0`!```"`D0!`#L`');

##################################################
sub logmsg {
##################################################
    my $msg = join(' ', @_);

    my ($sec,$min,$hour,$mday,$mon,$year) =
                                  localtime(time);
    open(LOG, ">>$LOG_FILE") || 
        die "Cannot open $LOG_FILE";

    flock(LOG, 2);

    printf LOG "%d/%02d/%02d %02d:%02d:%02d ",
               $year+1900, $mon+1, $mday,
               $hour, $min, $sec;

    print LOG "$msg\n";

    close(LOG);
}
